Code/Areas/ApplicationManagement/Controllers/RBACController.cs
using Cyberanium.Factory;
using CyberaniumApi.Helpers;
using CyberaniumModels;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.Extensions.Logging;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Cyberanium.Areas.ApplicationManagement.Controllers
{
    [Area("ApplicationManagement")]
    public class RBACController : Controller
    {
        private readonly ILogger<RBACController> _logger;
        RBAC obj = new RBAC();
        public RBACController(ILogger<RBACController> logger)
        {
            _logger = logger;
        }
        public async Task<IActionResult> Index()
        {
            obj.Menues = await ApiClientFactory.Instance.GetMenu();
            obj.DdlRole = new SelectList(await ApiClientFactory.Instance.GetEnumByType(10), "Value", "Name");
            ViewBag.message = TempData["save"];
            ViewBag.error = TempData["error"];
            return View(obj);
        }
        [HttpPost]
        public async Task<IActionResult> Index(RBAC rBAC)
        {
            _logger.LogInformation("SubmitRole");
            rBAC.CreatedIP = HttpContext.Session.GetString("IP");
            rBAC.CreatedBy = (int)HttpContext.Session.GetInt32("UserId");
            var res = await ApiClientFactory.Instance.SubmitRole(rBAC);
            if (res.IsSuccess)
            {
                if (rBAC.Edit == "0") 
                {
                    TempData["save"] = "Save successfully!!";
                } else { TempData["save"] = "Update successfully!!"; }
                return RedirectToAction("Index", "RBAC");
            }
            TempData["error"] = "Somethig is worng??";
            return View();
        }
        [HttpGet]
        public async Task<IActionResult> GetRoleById(long id)
        {
            var res = id > 0 ? await ApiClientFactory.Instance.GetRoleById(id) : new List<RBAC>();
            //obj.Menues = res;
            //return View();
            return Json(res);
        }

    }
}

Code/Areas/Dashboard/Controllers/LandingController.cs
using Cyberanium.Factory;
using Cyberanium.Models;
using Cyberanium.Utility;
using CyberaniumModels;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Cyberanium.Areas.Dashboard.Controllers
{
    [Area("Dashboard")]
    public class LandingController : Controller
    {

        private readonly ILogger<LandingController> _logger;
        private readonly IOptions<MySettingsModel> appSettings;
        public LandingController(IOptions<MySettingsModel> app, ILogger<LandingController> logger)
        {
            appSettings = app;
            ApplicationSettings.WebApiUrl = appSettings.Value.WebApiBaseUrl;
            _logger = logger;
        }
        public async Task<IActionResult> Index()
        {
            RBAC model = new RBAC();
            RBAC obj = new RBAC();
            int EmpId = Convert.ToInt16(HttpContext.Session.GetInt32("UserId"));
            obj.ApprovalList = await ApiClientFactory.Instance.GetTaskCountByEmpId(EmpId);
            obj.EnablerList = await ApiClientFactory.Instance.GetEnablerAssessmentByEmpId(EmpId);
            obj.ComplianceList = await ApiClientFactory.Instance.GetComplianceRCMByEmpId(EmpId);
            var OrgList = obj.EnablerList.Select(x => x.OrgId).Distinct().ToList();
            foreach (var item in OrgList)
            {
                bool IsCompleted = obj.EnablerList.Where(x => x.OrgId == item).All(x => x.Status == 1);
                if (!IsCompleted)
                {
                    obj.Counts++;
                }
            }
            foreach (var item in obj.ComplianceList)
            {
                if (item.Status != 1)
                {
                    obj.Counts++;
                }


            }
            foreach (var item in obj.ApprovalList)
            {
                if (item.Status2 == 1)
                {
                    obj.Counts++;
                }


            }

            var RoleId = HttpContext.Session.GetInt32("Role");
            if (RoleId == 0 || RoleId == null)
            {
                TempData["error"] = "Session time out. Please try again.";
                return RedirectToAction("Login", "Login", new { area = "ApplicationManagement" });
            }
            var usr = User.Identity.Name;
            return View(obj);
        }

        public async Task<JsonResult> ShowType3(int Type)
        {
            var model = new RBAC();
            string str = string.Empty;
            int EmpId = Convert.ToInt16(HttpContext.Session.GetInt32("UserId"));
            model.ApprovalList = await ApiClientFactory.Instance.GetTaskCountByEmpId(EmpId);
            model.EnablerList = await ApiClientFactory.Instance.GetEnablerAssessmentByEmpId(EmpId);
            model.ComplianceList = await ApiClientFactory.Instance.GetComplianceRCMByEmpId(EmpId);
            if (Type == 1)
            {
                var OrgList = model.EnablerList.Select(x => x.OrgId).Distinct().ToList();
                foreach (var item in OrgList)
                {
                    bool IsCompleted = model.EnablerList.Where(x => x.OrgId == item).All(x => x.Status == 1);
                    if (!IsCompleted)
                    {
                        var _item = model.EnablerList.Where(x => x.OrgId == item).FirstOrDefault();
                        str = str + "<div><h2 class='h2class'>Details</h2><div class='row'><div class='col-12 p-2'><label>Assigned by :</label>" +
                                                      "<label> " + _item.UserName + " </label><br/><label>Time Stamp :</label><label>" + _item.CreatedOn + "</label><br/><label>Organization :</label>" +
                                                      "<label>" + _item.OrgName + "</label><br/><button type ='button' class='btn btn-primary'  onclick='fn_GotoEnablerAssessment(" + _item.OrgId + ",`" + _item.OrgName + "`);' >Take to the Task</button></div></div></div>";
                    }
                }
            }
            else if (Type == 2)
            {
                foreach (var item in model.ComplianceList)
                {
                    if (item.Status != 1)
                    {
                        str = str + "<div><h2 class='h2class'>Details</h2><div class='row'><div class='col-12 p-2'><label>Assigned by :</label>" +
                                  "<label>" + item.UserName + "</label><br/><label>Time Stamp :</label><label>" + item.CreatedOn + "</label><br/><label>Organization :</label>" +
                                  "<label>" + item.OrgName + "</label><br/><button type ='button' class='btn btn-primary' onclick='fn_GoToComplianceAssessment(" + item.OrgId + ",`" + item.OrgName + "`)'>Take to the Task</button></div></div></div>";
                    }


                }
            }
            else
            {
                foreach (var item in model.ApprovalList)
                {
                    if (item.Status2 == 1)
                    {
                        str = str + "<div><h2 class='h2class'>Details</h2><div class='row'><div class='col-12 p-2'><label>Assigned by :</label>" +
                                   "<label> " + @item.UserName + " </label><br/><label>Time Stamp :</label><label>" + @item.CreatedOn + "</label><br/><label>Organization :</label>" +
                                   "<label>" + @item.OrgName + "</label><br/><label>Task :</label><label>" + @item.EnablerName + "</label><br/><button type ='button' class='btn btn-primary' onclick='fn_GotoAssignedEnabler(" + item.OrgId + "," + item.CategoryId + "," + item.QuestionnaireID + ",`" + item.EnablerName + "`);'>Take to the Task</button></div></div></div>";
                    }


                }
            }

            return Json(str);
        }

        public async Task<IActionResult> ProcessView(int orgId = 0, int functionId = 0)
        {
            var model = new IRA();
            int EmployeeId = Convert.ToInt16(HttpContext.Session.GetInt32("UserId"));
            model.DdlParentOrg = new SelectList(await ApiClientFactory.Instance.GetAssignedOrganizationByEmplyoyeeID(EmployeeId), "Id", "OrgName");
            model.DdlProcess = new SelectList(await ApiClientFactory.Instance.BindFunctionProcess(orgId, functionId), "Id", "FunctionName");
            model.OrgId = orgId;
            model.FunctionList = await ApiClientFactory.Instance.GetFunctionByOrganization(orgId);
            model.FunctionList = model.FunctionList.Where(x => x.Id == functionId).ToList();
            model.ProcessList = await ApiClientFactory.Instance.GetProcessesByOrgId(orgId);
            model.ProcessList = model.ProcessList.Where(x => x.FunctionID == functionId).ToList();
            model.UserList = await ApiClientFactory.Instance.getClientadminFillData(orgId);
            return View(model);
        }

        public async Task<IActionResult> _ProcessTree(int orgId = 0, int functionId = 0)
        {
            string res = string.Empty;
            var model = new IRA();
            model.OrgId = orgId;
            model.FunctionList = await ApiClientFactory.Instance.GetFunctionByOrganization(orgId);
            model.FunctionList = model.FunctionList.Where(x => x.Id == functionId).ToList();
            model.ProcessList = await ApiClientFactory.Instance.GetProcessesByOrgId(orgId);
            model.ProcessList = model.ProcessList.Where(x => x.FunctionID == functionId).ToList();
            foreach (var item in model.ProcessList)
            {
                var Processid = item.Id;
                res = OrgFunctionList(orgId, functionId, Processid).ToString();
            }
            return View(model);
        }

        public async Task<IActionResult> ProcessTree(int orgId = 0, int functionId = 0)
        {
            string res = string.Empty;
            string FinalScore = string.Empty;
            var model = new IRA();
            model.OrgId = orgId;
            model.FunctionList = await ApiClientFactory.Instance.GetFunctionByOrganization(orgId);
            var FunctionList = model.FunctionList.Where(x => x.Id == functionId).ToList();
            model.ProcessList = await ApiClientFactory.Instance.GetProcessesByOrgId(orgId);
            var ProcessList = model.ProcessList.Where(x => x.FunctionID == functionId && x.AssignToUserId == Convert.ToInt64(HttpContext.Session.GetInt32("UserId"))).ToList();
            FinalScore = await OrgFunctionList(orgId, functionId, 0);
            return Json(new { FunctionList, ProcessList, FinalScore });
        }
        public async Task<string> OrgFunctionList(int orgId = 0, int functionId = 0, int processId = 0)
        {
            long userId = Convert.ToInt64(HttpContext.Session.GetInt32("UserId"));
            var ProcessList = await ApiClientFactory.Instance.GetProcessesByOrgId(orgId);
            var _ProcessList = ProcessList.Where(x => x.FunctionID == functionId && x.AssignToUserId == userId).ToList();
            decimal fscore1 = 0, fscore2 = 0, fscore3 = 0, fscore4 = 0, fscore5 = 0;
            decimal frd1 = 0, frd2 = 0, frd3 = 0, frd4 = 0, frd5 = 0;
            decimal dc1 = 0, dc2 = 0, dc3 = 0, dc4 = 0, dc5 = 0;
            foreach (var item in _ProcessList)
            {
                var parameterList = await ApiClientFactory.Instance.GetConCatListByIds(orgId, functionId, item.Id);
                var str = parameterList.GroupBy(x => new { x.CategoryId, x.CategoryName }).ToList();
                var res = await ApiClientFactory.Instance.GetDomainCriticalityScoreByProcessesId(orgId, functionId, item.Id);
                var res5 = res.Where(x => x.ParameterId == 5).ToList();
                var rowdata = new List<ClientEnablers>();
                decimal rd1 = 0, rd2 = 0, rd3 = 0, rd4 = 0, rd5 = 0;

Code/Areas/ApplicationManagement/Views/RBAC/Index.cshtml
@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.RBAC
<section>
    <style>
        tr td:first-child {
            text-align: left !important;
        }
        .s_btn {
            width: 87px;
            border: none;
            outline: none;
            height: 40px;
            background-color: #005eb8;
            color: #fff;
            font-size: 15px;
            float: right;
            vertical-align: middle;
            padding: 11px 14px;
        }
            .s_btn:hover {
                color: #fff;
            }
        .backtolist {
            margin-top: 3px !important;
        }
        a:hover {
            color: white;
        }
        .table_control {
            height: calc(100vh - 262px);
            padding: 0px 12px 15px;
            background: #f8f8f8;
            overflow-y: visible;
            overflow-y: auto;
        }
    </style>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Add Role</h1>
            <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="TabMenu" asp-controller="User" asp-area="ApplicationManagement">Back to Menu</a>

            <div class="titile_line"></div>
        </div>
        @if (ViewBag.message != null)
        {
            <script>toastr.success('@ViewBag.message')</script>
        }
        else if (ViewBag.error != null)
        {
            <script>toastr.error('@ViewBag.error')</script>
        }
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <form asp-area="ApplicationManagement" asp-controller="RBAC" asp-action="Index"
                          data-ajax="true"
                          data-ajax-method="POST"
                          data-ajax-mode="replace"
                          data-loading-text="loading..."
                          data-ajax-update="#ajaxresult"
                          data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/RBAC/Index');"
                          data-ajax-failure="Errmsg(data);"
                          enctype="multipart/form-data" id="RBAC" method="post">
                        <div class="row">
                            <div class="col-md-4 col-sm-6 col-xs-12">
                                <input type="hidden" asp-for="RBACXML" />
                                <label>Role</label>
                                <div class="select_box m_bottom">
                                    @Html.DropDownListFor(m => m.RoleId, Model.DdlRole, "Select Role", new { @class = "form-control m_no" })
                                </div>
                            </div>
                        </div>
                        <div class="tata_room">
                            <div class="table_control" id="Div_Report">
                                <table class="table" id="RoleBasedAccessControl">
                                    <thead>
                                        <tr>
                                            <th><input type="checkbox" name="name" value="" class="hidden" />MenuList</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @{ int i = 0;
                                            foreach (var item in Model.Menues.Where(x => x.ParentMenuId == 0 && x.ChildMenuId == 0))
                                            {
                                                <tr style="background-color:burlywood">
                                                    <td class="tdvalue">
                                                        <input type="checkbox" id="roleMenu_@item.MenuId" name="roleMenu_@item.MenuId" class="chk" value="@item.MenuId" onclick="fn_SelectallCheckBox(this,@item.MenuId)" />
                                                        <label for="roleMenu_@item.MenuId">@item.MenuName</label>
                                                    </td>
                                                </tr>
                                                i++;
                                                int t = 0;
                                                foreach (var menu in Model.Menues.Where(x => x.ParentMenuId == item.MenuId && x.ChildMenuId == 0))
                                                {
                                                    <tr>
                                                        <td>
                                                            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                                            <input type="checkbox" id="roleMenu_@menu.MenuId" name="childMenu_@item.MenuId" class="chk" onclick="fn_SelectAllSubMenu(this,@menu.MenuId)" value="@menu.MenuId" />
                                                            <label for="roleMenu_@menu.MenuId">@menu.MenuName</label>
                                                        </td>
                                                    </tr>
                                                    @*@if (menu.MenuType == 0)
                    {

                        t++;
                        int s = 0;
                        foreach (var sub in Model.Menues.Where(x => x.ParentMenuId == item.MenuId && x.ChildMenuId == menu.MenuId && x.SubMenuId == 0))
                        {
                            <tr>
                                <td>
                                    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                    <input type="checkbox" id="roleMenu_@sub.MenuId" name="subMenu_@menu.MenuId" class="chk" value="@sub.MenuId" />
                                    <label for="roleMenu_@sub.MenuId">@sub.MenuName</label>
                                </td>
                            </tr>
                            s++;
                        }
                    }
                    else
                    {
                        <tr>
                            <td>
                                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                <input type="checkbox" id="roleMenu_@menu.MenuId" name="childMenu_@item.MenuId" class="chk" onclick="fn_SelectAllSubMenu(this)" value="@menu.MenuId" />
                                <label for="roleMenu_@menu.MenuId">@menu.MenuName</label>
                            </td>
                        </tr>
                    }*@
                                                }
                                            }
                                        }
                                    </tbody>
                                </table>
                            </div>
                        </div>
                      
                        <div class="row pt-3">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <div class="back_btn">
                                    <div class="back_btn_in">
                                        <a class="s_btn btn_left" asp-area="Dashboard" asp-action="Index" asp-controller="Landing">Cancel</a>
                                    </div>
                                </div>
                                <div class="submitbtn">
                                    <input type="submit" class="s_btn btn_right" value="Submit" />
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                </div>
            </div>
        </div>
    </div>
</section>
<script>
    $("input[type=submit]").click(function () {
        var parent = [];
        $('.chk:checked').each(function (i) {
            parent[i] = { ParentMenuId: parseInt($(this).val()) }
        });
        $("input[name=RBACXML]").val(JSON.stringify(parent));
        var role = $("#RoleId").val();
        if (role === "") {
            toastr.error('Role is required.');
            return false;
        }
    });
    function fn_SelectallCheckBox(e,MenuID) {
        if (e.checked) {
            $("input[name=childMenu_" + MenuID + "]").prop("checked", true);
            $("input[id=roleMenu_" + MenuID + "]").prop("checked", true);

        } else {
            $("input[name=childMenu_" + MenuID + "]").attr("checked", false);
            $("input[id=roleMenu_" + MenuID + "]").attr("checked", false);
        }
    }
    let totalSub = 0;
    function fn_SelectAllSubMenu(e,MenuID) {
        if (e.checked) {
            $("input[name=subMenu_" + MenuID + "]").prop("checked", true);
        } else {
            $("input[name=subMenu_" + MenuID + "]").attr("checked", false);
        }
    }
    $("select[name=RoleId]").change(function (e) {
        $.ajax({
            url: "/ApplicationManagement/RBAC/GetRoleById",
            type: "GET",
            data: { id: e.target.value },
            success: function (response) {
                if (response.length > 0) {
                    debugger
                    $('input[type=checkbox]').attr('checked', false);
                    for (var i = 0; i < response.length;i++) {
                        debugger
                        $('input[id=roleMenu_' + response[i].menuId + ']').prop('checked', 'checked');
                    //    $('input[type=checkbox]').each(function (j) {
                    //        var chk = $('input[id=roleMenu_' + j + ']').val();
                    //        if (response[i].menuId == chk) {
                    //            i++
                    //        }
                    //    });
                    }
                    $("#preloader").hide();
                } else {
                    $('input[type=checkbox]').attr('checked', false);
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        });
    });
</script>